# coding: utf-8

"""
    Guardrails API

    Guardrails CRUD API

    The version of the OpenAPI document: 0.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Set
from typing_extensions import Self

class Core(BaseModel):
    """
    Core
    """ # noqa: E501
    anchor: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, alias="$anchor")
    ref: Optional[str] = Field(default=None, alias="$ref")
    dynamic_ref: Optional[str] = Field(default=None, alias="$dynamicRef")
    dynamic_anchor: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, alias="$dynamicAnchor")
    vocabulary: Optional[Dict[str, StrictBool]] = Field(default=None, alias="$vocabulary")
    comment: Optional[str] = Field(default=None, alias="$comment")
    defs: Optional[Dict[str, Any]] = Field(default=None, alias="$defs")
    __properties: ClassVar[List[str]] = ["$anchor", "$ref", "$dynamicRef", "$dynamicAnchor", "$vocabulary", "$comment", "$defs"]

    @field_validator('anchor')
    def anchor_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Za-z_][-A-Za-z0-9._]*$", value):
            raise ValueError(r"must validate the regular expression /^[A-Za-z_][-A-Za-z0-9._]*$/")
        return value

    @field_validator('dynamic_anchor')
    def dynamic_anchor_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Za-z_][-A-Za-z0-9._]*$", value):
            raise ValueError(r"must validate the regular expression /^[A-Za-z_][-A-Za-z0-9._]*$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Core from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Core from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "$anchor": obj.get("$anchor"),
            "$ref": obj.get("$ref"),
            "$dynamicRef": obj.get("$dynamicRef"),
            "$dynamicAnchor": obj.get("$dynamicAnchor"),
            "$comment": obj.get("$comment"),
        })
        return _obj


